DefaultTlsCipherFactory (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.crypto.tls

## Class DefaultTlsCipherFactory

- java.lang.Object
- - org.bouncycastle.crypto.tls.AbstractTlsCipherFactory
  - - org.bouncycastle.crypto.tls.DefaultTlsCipherFactory

- All Implemented Interfaces:
    TlsCipherFactory

      public class DefaultTlsCipherFactory
      extends AbstractTlsCipherFactory

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultTlsCipherFactory()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected AEADBlockCipher` | `createAEADBlockCipher_AES_CCM()`
    `protected AEADBlockCipher` | `createAEADBlockCipher_AES_GCM()`
    `protected AEADBlockCipher` | `createAEADBlockCipher_Camellia_GCM()`
    `protected BlockCipher` | `createAESBlockCipher()`
    `protected TlsBlockCipher` | `createAESCipher(TlsContext context, int cipherKeySize, int macAlgorithm)`
    `protected BlockCipher` | `createAESEngine()`
    `protected BlockCipher` | `createCamelliaBlockCipher()`
    `protected TlsBlockCipher` | `createCamelliaCipher(TlsContext context, int cipherKeySize, int macAlgorithm)`
    `protected BlockCipher` | `createCamelliaEngine()`
    `protected TlsCipher` | `createChaCha20Poly1305(TlsContext context)`
    `protected TlsAEADCipher` | `createCipher_AES_CCM(TlsContext context, int cipherKeySize, int macSize)`
    `protected TlsAEADCipher` | `createCipher_AES_GCM(TlsContext context, int cipherKeySize, int macSize)`
    `protected TlsAEADCipher` | `createCipher_Camellia_GCM(TlsContext context, int cipherKeySize, int macSize)`
    `TlsCipher` | `createCipher(TlsContext context, int encryptionAlgorithm, int macAlgorithm)` See enumeration classes EncryptionAlgorithm, MACAlgorithm for appropriate argument values
    `protected BlockCipher` | `createDESedeBlockCipher()`
    `protected TlsBlockCipher` | `createDESedeCipher(TlsContext context, int macAlgorithm)`
    `protected Digest` | `createHMACDigest(int macAlgorithm)`
    `protected TlsNullCipher` | `createNullCipher(TlsContext context, int macAlgorithm)`
    `protected TlsStreamCipher` | `createRC4Cipher(TlsContext context, int cipherKeySize, int macAlgorithm)`
    `protected StreamCipher` | `createRC4StreamCipher()`
    `protected TlsStreamCipher` | `createSalsa20Cipher(TlsContext context, int rounds, int cipherKeySize, int macAlgorithm)`
    `protected StreamCipher` | `createSalsa20StreamCipher(int rounds)`
    `protected BlockCipher` | `createSEEDBlockCipher()`
    `protected TlsBlockCipher` | `createSEEDCipher(TlsContext context, int macAlgorithm)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultTlsCipherFactory

          public DefaultTlsCipherFactory()

  - ### Method Detail

    - #### createCipher

          public TlsCipher createCipher(TlsContext context,
                               int encryptionAlgorithm,
                               int macAlgorithm)
                                 throws java.io.IOException

      Description copied from interface: `TlsCipherFactory`
      See enumeration classes EncryptionAlgorithm, MACAlgorithm for appropriate argument values
      Specified by:
        `createCipher` in interface `TlsCipherFactory`
      Overrides:
        `createCipher` in class `AbstractTlsCipherFactory`
      Throws:
        `java.io.IOException`

    - #### createAESCipher

          protected TlsBlockCipher createAESCipher(TlsContext context,
                                       int cipherKeySize,
                                       int macAlgorithm)
                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createCamelliaCipher

          protected TlsBlockCipher createCamelliaCipher(TlsContext context,
                                            int cipherKeySize,
                                            int macAlgorithm)
                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createChaCha20Poly1305

          protected TlsCipher createChaCha20Poly1305(TlsContext context)
                                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createCipher_AES_CCM

          protected TlsAEADCipher createCipher_AES_CCM(TlsContext context,
                                           int cipherKeySize,
                                           int macSize)
                                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createCipher_AES_GCM

          protected TlsAEADCipher createCipher_AES_GCM(TlsContext context,
                                           int cipherKeySize,
                                           int macSize)
                                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createCipher_Camellia_GCM

          protected TlsAEADCipher createCipher_Camellia_GCM(TlsContext context,
                                                int cipherKeySize,
                                                int macSize)
                                                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createDESedeCipher

          protected TlsBlockCipher createDESedeCipher(TlsContext context,
                                          int macAlgorithm)
                                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createNullCipher

          protected TlsNullCipher createNullCipher(TlsContext context,
                                       int macAlgorithm)
                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createRC4Cipher

          protected TlsStreamCipher createRC4Cipher(TlsContext context,
                                        int cipherKeySize,
                                        int macAlgorithm)
                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createSalsa20Cipher

          protected TlsStreamCipher createSalsa20Cipher(TlsContext context,
                                            int rounds,
                                            int cipherKeySize,
                                            int macAlgorithm)
                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createSEEDCipher

          protected TlsBlockCipher createSEEDCipher(TlsContext context,
                                        int macAlgorithm)
                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createAESEngine

          protected BlockCipher createAESEngine()

    - #### createCamelliaEngine

          protected BlockCipher createCamelliaEngine()

    - #### createAESBlockCipher

          protected BlockCipher createAESBlockCipher()

    - #### createAEADBlockCipher_AES_CCM

          protected AEADBlockCipher createAEADBlockCipher_AES_CCM()

    - #### createAEADBlockCipher_AES_GCM

          protected AEADBlockCipher createAEADBlockCipher_AES_GCM()

    - #### createAEADBlockCipher_Camellia_GCM

          protected AEADBlockCipher createAEADBlockCipher_Camellia_GCM()

    - #### createCamelliaBlockCipher

          protected BlockCipher createCamelliaBlockCipher()

    - #### createDESedeBlockCipher

          protected BlockCipher createDESedeBlockCipher()

    - #### createRC4StreamCipher

          protected StreamCipher createRC4StreamCipher()

    - #### createSalsa20StreamCipher

          protected StreamCipher createSalsa20StreamCipher(int rounds)

    - #### createSEEDBlockCipher

          protected BlockCipher createSEEDBlockCipher()

    - #### createHMACDigest

          protected Digest createHMACDigest(int macAlgorithm)
                                     throws java.io.IOException

      Throws:
        `java.io.IOException`